Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/H2SpatialNewStoreParameters.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/H2SpatialNewStoreParameters.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/H2SpatialNewStoreParameters.java	(revision 43377)
@@ -0,0 +1,71 @@
+/* gvSIG. Geographic Information System of the Valencian Government
+ *
+ * Copyright (C) 2007-2008 Infrastructures and Transports Department
+ * of the Valencian Government (CIT)
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation; either version 2
+ * of the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
+ * MA  02110-1301, USA.
+ *
+ */
+package org.gvsig.fmap.dal.store.h2;
+
+import java.io.File;
+import java.util.Properties;
+import org.gvsig.fmap.dal.exception.ValidateDataParametersException;
+import org.gvsig.fmap.dal.store.jdbc.JDBCNewStoreParameters;
+
+public class H2SpatialNewStoreParameters 
+    extends 
+        JDBCNewStoreParameters 
+    implements 
+        H2SpatialConnectionParameters 
+    {
+
+    private final H2SpatialConnectionParametersHelper helper;
+    
+    public H2SpatialNewStoreParameters() {
+        super(
+            H2SpatialLibrary.NAME + "NewStoreParameters", 
+            H2SpatialLibrary.NAME
+        );
+        this.helper = new H2SpatialConnectionParametersHelper(this);
+    }
+
+    @Override
+    public String getUrl() {
+        return this.helper.getUrl();
+    }
+    
+    @Override
+    public void validate() throws ValidateDataParametersException {
+        this.helper.validate();
+    }
+
+    @Override
+    public Properties getProperties() {
+        return this.helper.getProperties();
+    }
+
+    @Override
+    public File getFile() {
+        return this.helper.getFile();
+    }
+    
+    @Override
+    public void setFile(File database) {
+        this.helper.setFile(database);
+    }
+
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/operations/H2SpatialListTablesOperation.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/operations/H2SpatialListTablesOperation.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/operations/H2SpatialListTablesOperation.java	(revision 43377)
@@ -0,0 +1,49 @@
+package org.gvsig.fmap.dal.store.h2.operations;
+
+import java.sql.Connection;
+import java.sql.ResultSet;
+import java.sql.SQLException;
+import java.util.ArrayList;
+import java.util.List;
+import org.gvsig.fmap.dal.store.jdbc.JDBCStoreParameters;
+import org.gvsig.fmap.dal.store.jdbc2.JDBCHelper;
+import org.gvsig.fmap.dal.store.jdbc2.JDBCUtils;
+import org.gvsig.fmap.dal.store.jdbc2.spi.operations.ListTablesOperation;
+
+public class H2SpatialListTablesOperation extends ListTablesOperation {
+
+    public H2SpatialListTablesOperation(JDBCHelper helper, int mode, JDBCStoreParameters baseParameters, boolean informationTables) {
+        super(helper, mode, baseParameters, informationTables);
+    }
+
+    @Override
+    public List<JDBCStoreParameters> listTables(
+            Connection conn,
+            int mode,
+            JDBCStoreParameters baseParameters,
+            boolean informationTables
+    ) {
+        ResultSet rs = null;
+        List<JDBCStoreParameters> tables = new ArrayList<>();
+
+        try {
+            String sql = "SELECT TABLE_CATALOG, TABLE_SCHEMA, TABLE_NAME FROM INFORMATION_SCHEMA.TABLES where table_type in ('TABLE','VIEW','EXTERNAL')";
+            rs = conn.createStatement().executeQuery(sql);
+            while (rs.next()) {
+                JDBCStoreParameters params = baseParameters.getCopy();
+                params.setCatalog(rs.getString("TABLE_CATALOG"));
+                params.setSchema(rs.getString("TABLE_SCHEMA"));
+                params.setTable(rs.getString("TABLE_NAME"));
+                tables.add(params);
+            }
+            return tables;
+            
+        } catch (SQLException ex) {
+            throw new RuntimeException("Can't fetch tables information",ex);
+            
+        } finally {
+            JDBCUtils.closeQuietly(rs);
+        }
+
+    }
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/operations/H2SpatialFetchFeatureTypeOperation.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/operations/H2SpatialFetchFeatureTypeOperation.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/operations/H2SpatialFetchFeatureTypeOperation.java	(revision 43377)
@@ -0,0 +1,202 @@
+
+package org.gvsig.fmap.dal.store.h2.operations;
+
+import java.sql.Connection;
+import java.sql.ResultSet;
+import java.sql.ResultSetMetaData;
+import java.sql.SQLException;
+import java.sql.Statement;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+import org.apache.commons.lang3.StringUtils;
+import org.cresques.cts.IProjection;
+import org.gvsig.fmap.dal.DataTypes;
+import org.gvsig.fmap.dal.exception.DataException;
+import org.gvsig.fmap.dal.feature.EditableFeatureAttributeDescriptor;
+import org.gvsig.fmap.dal.feature.EditableFeatureType;
+import org.gvsig.fmap.dal.store.jdbc2.JDBCHelper;
+import org.gvsig.fmap.dal.store.jdbc2.JDBCUtils;
+import org.gvsig.fmap.dal.store.jdbc2.spi.operations.FetchFeatureTypeOperation;
+import org.gvsig.fmap.geom.Geometry;
+import org.gvsig.fmap.geom.GeometryLocator;
+import org.gvsig.fmap.geom.GeometryManager;
+import org.gvsig.fmap.geom.type.GeometryType;
+
+public class H2SpatialFetchFeatureTypeOperation extends FetchFeatureTypeOperation {
+
+    private static Map<String,GeometryType>h2spatialGeometryTypes = null;
+    private Map<String,GeometryColumnInfo> geometry_column;
+    
+    private static class GeometryColumnInfo {
+        
+        public String columnName;
+        public int geometryType;
+        public String geometryTypeName;
+        public int dimensions;
+        public int srid;
+        
+        public GeometryColumnInfo(String columnName, int geometryType, String geometryTypeName, int dimensions, int srid) {
+            this.columnName = columnName;
+            this.geometryType = geometryType;
+            this.geometryTypeName = geometryTypeName;
+            this.dimensions = dimensions;
+            this.srid = srid;
+        }
+    }
+    
+    
+    public H2SpatialFetchFeatureTypeOperation(
+            JDBCHelper helper
+        ) {
+        super(helper);
+    }
+
+    private GeometryType getGT(
+            GeometryManager manager, 
+            int type, 
+            int subtype
+        ) {
+        try {
+            return manager.getGeometryType(type, subtype);
+        } catch (Exception ex) {
+            return null;
+        }
+    }
+    
+    public H2SpatialFetchFeatureTypeOperation(
+            JDBCHelper helper,
+            EditableFeatureType featureType,
+            String dbname,
+            String schema,
+            String table,
+            List<String> primaryKeys,
+            String defaultGeometryColumn,
+            IProjection crs
+        ) {
+        super(helper, featureType, dbname, schema, table, primaryKeys, defaultGeometryColumn, crs);
+    }            
+
+    @Override
+    public void fetch(EditableFeatureType featureType, Connection conn, String dbname, String schema, String table, List<String> pks, String defaultGeometryColumn, IProjection crs) throws DataException {
+        geometry_column = new HashMap<>();
+        try {
+            //
+            // https://github.com/orbisgis/h2gis/wiki/1.-Spatial-data#geometry-columns-view
+            //
+            StringBuilder where = null;
+            if( !StringUtils.isEmpty(dbname) ) {
+                if( where == null ) {
+                    where = new StringBuilder();
+                } else {
+                    where.append(" AND ");
+                }
+                where.append("UPPER(F_TABLE_CATALOG) = '");
+                where.append(dbname.toUpperCase());
+                where.append("'");
+            }
+            if( !StringUtils.isEmpty(schema) ) {
+                if( where == null ) {
+                    where = new StringBuilder();
+                } else {
+                    where.append(" AND ");
+                }
+                where.append("UPPER(F_TABLE_SCHEMA) = '");
+                where.append(schema.toUpperCase());
+                where.append("'");
+            }
+            if( !StringUtils.isEmpty(table) ) {
+                if( where == null ) {
+                    where = new StringBuilder();
+                } else {
+                    where.append(" AND ");
+                }
+                where.append("UPPER(F_TABLE_NAME) = '");
+                where.append(table.toUpperCase());
+                where.append("'");
+            }            
+            String sql = "SELECT F_GEOMETRY_COLUMN, GEOMETRY_TYPE, COORD_DIMENSION, SRID, TYPE FROM GEOMETRY_COLUMNS WHERE " + where;
+            Statement st = this.getConnection().createStatement();
+            ResultSet rs = JDBCUtils.executeQuery(st,sql);
+            while( rs.next() ) {
+                geometry_column.put(
+                    rs.getString("F_GEOMETRY_COLUMN"), 
+                    new GeometryColumnInfo(
+                        rs.getString("F_GEOMETRY_COLUMN"), 
+                        rs.getInt("GEOMETRY_TYPE"), 
+                        rs.getString("TYPE"), 
+                        rs.getInt("COORD_DIMENSION"), 
+                        rs.getInt("SRID")
+                    )
+                );
+            }
+        } catch (SQLException ex) {
+            logger.warn("Can't read metadata from table '"+table+"'.",ex);
+        }
+        super.fetch(featureType, conn, dbname, schema, table, pks, defaultGeometryColumn, crs);
+    }
+        
+    @Override
+    protected void fetchGeometryTypeAndSRS(
+            EditableFeatureAttributeDescriptor attr,
+            ResultSetMetaData rsMetadata,
+            int colIndex
+        ) {
+        if( attr.getType()==DataTypes.GEOMETRY ) {
+            GeometryColumnInfo column_info = this.geometry_column.get(attr.getName());
+            String type = "GEOMETRY";
+            if( column_info!=null ) {
+                // H2GIS solo soporte 2D y 3D no soporta Ms
+                if( column_info.dimensions==3 ) {
+                    type = column_info.geometryTypeName+"Z";
+                } else {
+                    type = column_info.geometryTypeName;
+                }
+                attr.setSRS(
+                    this.helper.getProjectionFromDatabaseCode(
+                        String.valueOf(column_info.srid)
+                    )
+                );
+            }
+            GeometryType gt = getGeometryTypeFromH2SpatialType(type);
+            if( gt != null ) {
+                attr.setGeometryType(gt);
+            }
+        }
+    }
+
+    private GeometryType getGeometryTypeFromH2SpatialType(String typeName) {
+        if( h2spatialGeometryTypes==null ) {
+            //
+            // https://github.com/orbisgis/h2gis/wiki/1.-Spatial-data#geometry-columns-view
+            //
+            GeometryManager manager = GeometryLocator.getGeometryManager();
+            h2spatialGeometryTypes = new HashMap<>();
+            h2spatialGeometryTypes.put("POINT", getGT(manager, Geometry.TYPES.POINT,Geometry.SUBTYPES.GEOM2D));
+            h2spatialGeometryTypes.put("POINTZ", getGT(manager, Geometry.TYPES.POINT,Geometry.SUBTYPES.GEOM3D));
+            
+            h2spatialGeometryTypes.put("LINESTRING", getGT(manager, Geometry.TYPES.LINE,Geometry.SUBTYPES.GEOM2D));
+            h2spatialGeometryTypes.put("LINESTRINGZ", getGT(manager, Geometry.TYPES.LINE,Geometry.SUBTYPES.GEOM3D));
+            
+            h2spatialGeometryTypes.put("POLYGON", getGT(manager, Geometry.TYPES.POLYGON,Geometry.SUBTYPES.GEOM2D));
+            h2spatialGeometryTypes.put("POLYGONZ", getGT(manager, Geometry.TYPES.POLYGON,Geometry.SUBTYPES.GEOM3D));
+
+            h2spatialGeometryTypes.put("MULTIPOINT", getGT(manager, Geometry.TYPES.MULTIPOINT,Geometry.SUBTYPES.GEOM2D));
+            h2spatialGeometryTypes.put("MULTIPOINTZ", getGT(manager, Geometry.TYPES.MULTIPOINT,Geometry.SUBTYPES.GEOM3D));
+
+            h2spatialGeometryTypes.put("MULTILINESTRING", getGT(manager, Geometry.TYPES.MULTILINE,Geometry.SUBTYPES.GEOM2D));
+            h2spatialGeometryTypes.put("MULTILINESTRINGZ", getGT(manager, Geometry.TYPES.MULTILINE,Geometry.SUBTYPES.GEOM3D));
+
+            h2spatialGeometryTypes.put("MULTIPOLYGON", getGT(manager, Geometry.TYPES.MULTIPOLYGON,Geometry.SUBTYPES.GEOM2D));
+            h2spatialGeometryTypes.put("MULTIPOLYGONZ", getGT(manager, Geometry.TYPES.MULTIPOLYGON,Geometry.SUBTYPES.GEOM3D));
+
+            h2spatialGeometryTypes.put("GEOMETRY", getGT(manager, Geometry.TYPES.GEOMETRY,Geometry.SUBTYPES.GEOM2D));
+            h2spatialGeometryTypes.put("GEOMETRYZ", getGT(manager, Geometry.TYPES.GEOMETRY,Geometry.SUBTYPES.GEOM3D));
+
+            h2spatialGeometryTypes.put("GEOMCOLLECTION", getGT(manager, Geometry.TYPES.GEOMETRY,Geometry.SUBTYPES.GEOM2D));
+            h2spatialGeometryTypes.put("GEOMCOLLECTIONZ", getGT(manager, Geometry.TYPES.GEOMETRY,Geometry.SUBTYPES.GEOM3D));
+        }
+        return h2spatialGeometryTypes.get(typeName);
+    }
+    
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/operations/H2SpatialOperationsFactory.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/operations/H2SpatialOperationsFactory.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/operations/H2SpatialOperationsFactory.java	(revision 43377)
@@ -0,0 +1,35 @@
+
+package org.gvsig.fmap.dal.store.h2.operations;
+
+import java.util.List;
+import org.cresques.cts.IProjection;
+import org.gvsig.fmap.dal.feature.EditableFeatureType;
+import org.gvsig.fmap.dal.store.jdbc.JDBCStoreParameters;
+import org.gvsig.fmap.dal.store.jdbc2.JDBCHelper;
+import org.gvsig.fmap.dal.store.jdbc2.spi.operations.FetchFeatureTypeOperation;
+import org.gvsig.fmap.dal.store.jdbc2.spi.operations.ListTablesOperation;
+import org.gvsig.fmap.dal.store.jdbc2.spi.operations.OperationsFactoryBase;
+
+
+public class H2SpatialOperationsFactory extends OperationsFactoryBase {
+    
+    public H2SpatialOperationsFactory(JDBCHelper helper) {
+        super(helper);
+    }
+
+    @Override
+    public FetchFeatureTypeOperation createFetchFeatureType(EditableFeatureType type, String database, String schema, String table, List<String> primaryKeys, String defaultGeometryField, IProjection crs) {
+        return new H2SpatialFetchFeatureTypeOperation(
+                helper, type, database, schema, table, primaryKeys, 
+                defaultGeometryField, crs
+        );
+    }  
+
+    @Override
+    public ListTablesOperation createListTables(int mode, JDBCStoreParameters baseParameters, boolean informationTables) {
+        return new H2SpatialListTablesOperation(helper, mode, baseParameters, informationTables);
+    }
+    
+    
+    
+}
